﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Drawing.Design;
using System.Linq;
using System.Reflection;
using System.Web;

namespace WindowsFormsApp1
{
    [RefreshProperties(RefreshProperties.All)]
    public class DataItem
    {
        public DataItem()
        {
            A = false;
        }

        private bool _a;
        public bool A {
            get
            {
                return _a;
            }
            set
            {
                _a = value;
                PropertyDescriptor descriptor = TypeDescriptor.GetProperties(this.GetType())["B"];
                BrowsableAttribute attrib = (BrowsableAttribute)descriptor.Attributes[typeof(BrowsableAttribute)];
                FieldInfo isBrow = attrib.GetType().GetField("browsable", BindingFlags.NonPublic | BindingFlags.Instance);
                isBrow.SetValue(attrib, value);
            }
        }

        [Browsable(true)]
        public int B { get; set; }
    }
}